/*
	$Id: EnumMember.java 294 2006-09-06 15:57:45Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
   ¤ΤΥФޤ϶ΤΥФΤenumΥФǤ

   Υ饹ɽФEnumФȸƤӤޤΥФοƤϹ¤
   Τޤ϶ΤǤ

   enummemberǤбޤ
*/
public class EnumMember extends CompoundMember {

    /**
       EnumФޤ

       @param g 饹
       @param parentName Ƥ̾
       @param tag ̾
       @param elem enummember
    */
    public EnumMember(final Class g, final String parentName,
		      final String tag, final Element elem) {
	super(parentName, (tag.equals("") ? "enum" : "enum " + tag), elem);

	String implName = tag;
	if (implName.equals("")) {
	    implName = "@" + IDManager.getInstance().getUniqueID();
	    setDescType("enum " + implName);
	}
	setCompoundImpl(new CompoundImpl(g, "enum", elem, implName,
					 getDescType()) {
	    protected String getTagName() {
		return Enum.TAG_NAME;
	    }
	    protected Description getDescription(final ChildrenFilter c) {
		return CompoundMember.getDescription(c);
	    }
	    protected Components getComponents(final Class g,
					       final String descType,
					       final NodeList nodes) {
		return new Constants(g, nodes);
	    }
	});
    }
}
