/*
	$Id: StructUnionMember.java 294 2006-09-06 15:57:45Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
   ¤ΤΥФޤ϶ΤΥФΤstructޤunionΥ
   ФǤ

   Υ饹ɽФStructUnionФȸƤӤޤΥФο
   Ϲ¤Τޤ϶ΤǤ

   structmemberǡunionmemberǤбޤ
*/
public class StructUnionMember extends CompoundMember {

    /**
       StructUnionФޤ

       @param g 饹
       @param parentName Ƥ̾
       @param label "struct" ޤ "union"
       @param tag ̾
       @param elem structmemberǤޤunionmember
    */
    public StructUnionMember(final Class g, final String parentName,
			     final String label, final String tag,
			     final Element elem) {
	super(parentName, (tag.equals("") ? label : label + " " + tag), elem);

	String implName = tag;
	if (implName.equals("")) {
	    implName = "@" + IDManager.getInstance().getUniqueID();
	    setDescType(label + " " + implName);
	}
	setCompoundImpl(new CompoundImpl(g, label, elem, implName,
					 getDescType()) {
	    protected String getTagName() {
		return StructUnion.TAG_NAME;
	    }
	    protected Description getDescription(final ChildrenFilter c) {
		return CompoundMember.getDescription(c);
	    }
	    protected Components getComponents(final Class g,
					       final String descType,
					       final NodeList nodes) {
		return new Members(g, descType, nodes);
	    }
	});
    }
}
