/*
	$Id: Typedef.java 299 2006-12-09 18:10:07Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   Ǥ

   typedefǤбޤ
*/
public class Typedef {

    /** ̾ */
    private String name;

    /** type° */
    private String type;

    /** descǤ */
    private Description desc;

    /**
       ޤ

       @param g 饹
       @param elem typedef
    */
    public Typedef(final Class g, final Element elem) {
	name = g.expandNS(elem, "name");
	type = g.expandAT(elem, "type");
	g.importTags(type);

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       ̾ޤ

       @return ̾
    */
    public String getName() {
	return name;
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    wr.println("typedef "
		       + type.substring(0, k)
		       + name
		       + type.substring(k + 1)
		       + ";");
	} else {
	    wr.println("typedef " + type + " " + name + ";");
	}
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	wr.println(""
+ "<tr>\n"
+ "  <td><a href=\"#" + name + "\"><b>" + name + "</b></a><br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	wr.print(""
+ "<p><a name=\"" + name + "\"></a>"
+ "<font size=\"+1\"><b>" + name + "</b></font></p>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n"
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	wr.println("\\Sid{" + Tex.safe(name) + "}");
	wr.println(desc.getTexText());
    }
}
